
/******************************************************************************
* MODULE     : conv_ambiguous.cc
* DESCRIPTION: Ambiguous return values
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <quantor.hh>
#include <xtable.hh>
namespace mmx {

void
evaluator_rep::kw_conv_ambiguous_1 () {
  // INPUT: (conv_ambiguous_1, cont, ...)
  list instr= as_list (car (trace));
  generic val = cons (MMX_AMBIGUOUS, env, cddr (instr));
  generic type= cadr (instr);
  cur= cadr (rem);
  rem= cons (value (val, type), cddr (rem));
  // OUTPUT: (cont, ambiguous_value, ...)
  trace= cdr (trace);
}

} // namespace mmx
