
/******************************************************************************
* MODULE     : keyw_split.cc
* DESCRIPTION: The 'split' keyword
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <xtable.hh>
namespace mmx {

static list
continuation_list (list l, gentable env, list trace, list rem) {
  if (nil (l)) return l;
  else {
    gentable loc_env= xtable (env, table ());
    generic cont= cons (loc_env, trace, car (l), rem);
    return cons (cont, continuation_list (cdr (l), env, trace, rem));
  }
}

void
evaluator_rep::kw_split_1 () {
  list l= cdr (as_list (car (trace)));
  l= continuation_list (l, env, trace, cons (KW_SPLIT_2, rem));
  list todo= l * as_list (env [MISC_TODO]);
  env (MISC_TODO)= todo;
  kw_join_3 ();
}

void
evaluator_rep::kw_split_2 () {
  // INPUT: (split_2, result, cont, ...)
  xtable xenv= as_xtable (env);
  env= xenv->base_t;
  cur= cadr (rem);
  rem= cons (car (rem), cddr (rem));
  // OUTPUT: (cont, join_res, ...)
  trace= cdr (trace);
}

} // namespace mmx
