
/******************************************************************************
* MODULE     : keyw_yield.cc
* DESCRIPTION: The 'yield' keyword
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <alias.hh>
#include <gentable.hh>
namespace mmx {

void
evaluator_rep::kw_yield_1 () {
  if (env->contains (MISC_YIELD)) {
    generic val = VAL_NONE;
    generic type= env [MISC_YIELD];
    if (N(car(trace)) > 1) val= car(trace)[1];
    evaluate_arg (list (MMX_TRANSTYPE, val, type), KW_YIELD_2);
  }
  else error (car(trace), "Not inside a generate");
}

void
evaluator_rep::kw_yield_2 () {
  // INPUT: (yield_2, ret_val, cont, ...)
  if (env->contains (MISC_GENERATE)) {
    alias a= as_alias (env [MISC_GENERATE]);
    a->ref= cons (env, cdr (trace), cadr (rem), VAL_NONE, cddr (rem));
    // CONTINUATION for next generation: (cont, none, ...)
  }
  else { error (car(trace), "Not inside a generate"); return; }

  if (env->contains (CONT_YIELD)) {
    list l= as_list (env [CONT_YIELD]);
    // CONTINUATION: (old_env, old_trace, old_cont, ...)
    env= as_gentable (car (l));
    cur= caddr (l);
    rem= cons (car (rem), cdddr (l));
    // OUTPUT: (old_cont, ret_val, ...)
    trace= as_list (cadr (l));
  }
  else error (car(trace), "Not inside a generate");
}

} // namespace mmx
