
/******************************************************************************
* MODULE     : alias.cc
* DESCRIPTION: Aliases
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <alias.hh>
namespace mmx {

/******************************************************************************
* Required functions for generic structures
******************************************************************************/

int
alias_rep::Type () {
  return ALIAS_TYPE;
}

int
alias_rep::Hash () {
  return ((int) (&ref)) >> 3;
}

bool
alias_rep::Equal (generic g) {
  if (gentype (g) != ALIAS_TYPE) return false;
  return alias (this) == as_alias (g);
}

void
alias_rep::Print (ostream& out) {
  out << alias (this);
}

} // namespace mmx
